#ifndef WINMINEREADER_H
#define WINMINEREADER_H

#include "SynthInput.h"

#define SYMBOL_UNKNOWN -1
#define SYMBOL_0 0
#define SYMBOL_1 1
#define SYMBOL_2 2
#define SYMBOL_3 3
#define SYMBOL_4 4
#define SYMBOL_5 5
#define SYMBOL_6 6
#define SYMBOL_7 7
#define SYMBOL_8 8
#define SYMBOL_NOT_CLICKED 9
#define SYMBOL_BOMB 10
#define SYMBOL_RED_BOMB 11
#define SYMBOL_CROSS_BOMB 12
#define SYMBOL_MINE_MARK 13
#define SYMBOL_QUESTION_MARK_DEPRESSED 14
#define SYMBOL_QUESTION_MARK 15

#define DIGIT_MINUS 10
#define DIGIT_NULL 11
#define DIGIT_0 0
#define DIGIT_1 1
#define DIGIT_2 2
#define DIGIT_3 3
#define DIGIT_4 4
#define DIGIT_5 5
#define DIGIT_6 6
#define DIGIT_7 7
#define DIGIT_8 8
#define DIGIT_9 9

#define FACE_OK 0
#define FACE_NOT_OK 1
#define FACE_FINISH 2
#define FACE_UNKNOWN 3

#define MAX_SQUARE_SYMBOLS 16
#define MAX_DIGIT_SYMBOLS 12
#define MAX_FACE_SYMBOLS 3

class WinMineReader
{
private:
	unsigned char **SquareSymbols[MAX_SQUARE_SYMBOLS];
	unsigned char **DigitSymbols[MAX_DIGIT_SYMBOLS];
	unsigned char **FaceSymbols[MAX_FACE_SYMBOLS];
	SynthInput oInput;
	char WinMineWindowName[100];
	int CellStartX, CellStartY, CellWidth, CellHeight;
	int GameWidth, GameHeight, GameCellsX, GameCellsY;
	int WindowWidth, WindowHeight;
	int DigitWidth, DigitHeight;
	int FaceWidth, FaceHeight;
	unsigned char **WindowData;

	void RowColToXY(int Row, int Col, int *x, int *y);
	void RowColToAbsoluteXY(int Row, int Col, int *x, int *y);
	int ReadDigitsAt(int x, int y);

public:
	char CharSymbol[MAX_SQUARE_SYMBOLS];
	int NumberOfMines, Seconds, FaceStatus;
	int **MineField;

	WinMineReader(char *winMineWindowName);
	~WinMineReader();
	void ActivateWindow();
	void DeleteWindowData();
	void CaptureWindow();
	int GetCellsX() { return GameCellsX; }
	int GetCellsY() { return GameCellsY; }
	int GetRows() { return GameCellsY; }
	int GetCols() { return GameCellsX; }
	int ReadSymbolAt(int Row, int Col);
	int ReadFace();
	void UpdateMineField();

	void SendKey(WORD Key);
	void MoveMouseTo(int Row, int Col);
	void LeftClick();
	void RightClick();
};

#endif
